#include <p18cxxx.h>
#include <xlcd.h>

#include "my_xlcd.h"

/********************************************************************
*       Function Name:  SetDDRamAddr                                *
*       Return Value:   void                                        *
*       Parameters:     CGaddr: display data address                *
*       Description:    This routine sets the display data address  *
*                       of the Hitachi HD44780 LCD controller. The  *
*                       user must check to see if the LCD controller*
*                       is busy before calling this routine.        *
********************************************************************/
void SetDDRamAddr(unsigned char DDaddr)
{
#ifdef BIT8                                     // 8-bit interface
        //TRIS_DATA_PORT = 0;                     // Make port output
        my_tris_data_port_eq(0);
        //DATA_PORT = DDaddr | 0b10000000;        // Write cmd and address to port
        my_data_port_eq(DDaddr | 0b10000000);
        RW_PIN = 0;                             // Set the control bits
        RS_PIN = 0;
        DelayFor18TCY();
        E_PIN = 1;                              // Clock the cmd and address in
        DelayFor18TCY();
        E_PIN = 0;
        DelayFor18TCY();
        //TRIS_DATA_PORT = 0xff;                  // Make port input
        my_tris_data_port_eq(0xff);
#else                                           // 4-bit interface
#ifdef UPPER                                    // Upper nibble  interface
        ///TRIS_DATA_PORT &= 0x0f;                 // Make port output
        my_tris_data_port_andeq(0x0f);
        //DATA_PORT &= 0x0f;                      // and write upper nibble
        my_data_port_andeq(0x0f);
        //DATA_PORT |= ((DDaddr | 0b10000000) & 0xf0);
        my_data_port_oreq((DDaddr | 0b10000000) & 0xf0);
#else                                           // Lower nibble interface
        //TRIS_DATA_PORT &= 0xf0;                 // Make port output
        my_tris_data_port_andeq(0xf0);
        //DATA_PORT &= 0xf0;                      // and write upper nibble
        my_data_port_andeq(0xf0);
        //DATA_PORT |= (((DDaddr | 0b10000000)>>4) & 0x0f);
        my_data_port_oreq(((DDaddr | 0b10000000)>>4) & 0x0f);
#endif
        RW_PIN = 0;                             // Set control bits
        RS_PIN = 0;
        DelayFor18TCY();
        E_PIN = 1;                              // Clock the cmd and address in
        DelayFor18TCY();
        E_PIN = 0;
#ifdef UPPER                                    // Upper nibble interface
        //DATA_PORT &= 0x0f;                      // Write lower nibble
        my_data_port_andeq(0x0f);
        //DATA_PORT |= ((DDaddr<<4)&0xf0);
        my_data_port_oreq((DDaddr<<4)&0xf0);
#else                                           // Lower nibble interface
        //DATA_PORT &= 0xf0;                      // Write lower nibble
        my_data_port_andeq(0xf0);
        //DATA_PORT |= (DDaddr&0x0f);
        my_data_port_oreq(DDaddr&0x0f);
#endif
        DelayFor18TCY();
        E_PIN = 1;                              // Clock the cmd and address in
        DelayFor18TCY();
        E_PIN = 0;
#ifdef UPPER                                    // Upper nibble interface
        //TRIS_DATA_PORT |= 0xf0;                 // Make port input
        my_tris_data_port_oreq(0xf0);
#else                                           // Lower nibble interface
        //TRIS_DATA_PORT |= 0x0f;                 // Make port input
        my_tris_data_port_oreq(0x0f);
#endif
#endif
        return;
}

